var mySecs = 1;
var myCounter = 0;

function setTimer(){	// starts seconds-counting
	document.getElementById("statusTime").innerText = mySecs;
	++mySecs;
}

function clearTimer(){	// stops seconds-counting when server sent a response
	window.clearInterval(myCounter);
	document.getElementById("statusTime").innerText = "";
}

function callInProgress(conn) {	// checks if a XmlHttpRequest is in progress
	switch ( conn.readyState ) {
	case 1: case 2: case 3:
		return true;
		break;
	default:
		return false;
		break;
	}
	clearTimer();
}

function AbortOnNoResponse(){	// Abort XmlHttpRequest after a certain time (function is called via "setTimeout")
	if ( callInProgress(conn) ) {
		conn.abort();
		showStatusMsg("NoResponse");	// declared in an object-array
	}
}

function importxml(){
	if ( !callInProgress(conn) ) {
		showStatusMsg("Updating");	// shows spinning wheel while updating data
		myUrl = GETURL + "dk=" + devKey + "&uk=" + myUserKey + "&cmd=" + XMLCMD;
		conn = new XMLHttpRequest();
		// Timers...
		myCounter = window.setInterval("setTimer()",1000);
		myTimeOut = window.setTimeout("AbortOnNoResponse()", 10000 * MAXREQUESTTIME);

		conn.open("GET", myUrl,true);
		conn.onreadystatechange=function() {
			requestOk = true;
			if (conn.readyState==4){
				clearTimer();
	        if (conn.status == 200) {
					response=conn.responseXML;
					if (response==null) {
						showStatusMsg("NoResponse");
					} else {
						//alert(conn.responseText); // output response as text. just for testing-purposes
						processxml(response);
					}
				} else {
					showStatusMsg(conn.statustext);
					alert(conn.statustext);
				}
			}
		}
		conn.send(null);
	} else {
		showStatusMsg("InProgress");
	}
}

function showdoc(myDoc){	// shows document-tree of a given xml-document (just for testing-purposes)
	for(var i=0 ; i < myDoc.childNodes.length ; i++){
		var myVar = myDoc.childNodes[i];
		var myName = myVar.nodeName;	var myVal = "";
		if (myVar.nodeType == 3) myVal = " : " + myVar.nodeValue;
		alert(myName + myVal);
		showdoc(myVar);
	}
}
function processxml( xmlDocument ) {
	//showdoc(xmlDocument);
	var myApiResults = xmlDocument.getElementsByTagName( "apiResults" );
	myRequestStatus = returnTag(myApiResults[0], "status");
	if (myRequestStatus == "success"){
		checkWidgetVersion(xmlDocument);		
		var arrSurveys = xmlDocument.getElementsByTagName( "survey" );
		if (arrSurveys.length > 0){	// There's at least one survey
			document.getElementById("popupMenu").options.length = 1;
			for (var i=0 ; i<arrSurveys.length; i++){
				myTagValues[i] = new Object();
				myTagValues[i]["Title"] = returnTag(arrSurveys[i], "title");
				myTagValues[i]["ctComplete"] = returnDelimitedNumber(returnTag(arrSurveys[i], "count_complete"));
				myTagValues[i]["ctAbandoned"] = returnDelimitedNumber(returnTag(arrSurveys[i], "count_abandoned"));
				myTagValues[i]["ctInProgress"] = returnDelimitedNumber(returnTag(arrSurveys[i], "count_inprogress"));
				myTagValues[i]["ctPartial"] = returnDelimitedNumber(returnTag(arrSurveys[i], "count_partial"));
				myTagValues[i]["link_edit"] = returnTag(arrSurveys[i], "link_edit");
				myTagValues[i]["link_reporting"] = returnTag(arrSurveys[i], "link_reporting");
				myTagValues[i]["link_preview"] = returnTag(arrSurveys[i], "link_preview");
				
				document.getElementById("popupMenu").options[i+1] = new Option(shortenString(myTagValues[i]["Title"]),i)
			}
			setPopupToLastSurvey();
		} else {	// No surveys, so show message to create one
			document.getElementById("popupMenu").options[1] = new Option("Create a new survey",-1)
			document.getElementById("popupMenu").options[1].selected = true;
			popupMenuChanged(document.getElementById("popupMenu"));
		}
		showStatusMsg("ok");
	} else { // An error occured!
		myRequestStatus = returnTag(myApiResults[0], "msg").toUpperCase();
		showStatusMsg(myRequestStatus);
	}
}

function setPopupToLastSurvey(){
	var mySelectList = document.getElementById("popupMenu");
	var myNumberOfOptions = mySelectList.options.length;
	var myOption = "1";
	if (mySurveyNameBackup != ""){
		for (var i=0 ; i<myNumberOfOptions ; i++){
			if (shortenString(mySelectList.options[i].text) == mySurveyNameBackup){
				myOption = i;
				alert("choose old survey");
			}
		}
	}
	mySelectList.options[myOption].selected = true;
	popupMenuChanged(mySelectList);
}

// THIS IS THE ONE USED - sm
// myVersion is  a misnomer, myVersion is actually the current widget version delivered via the XML
// WIDGETVERSION is taken from the Info.plist file and is the installed version
function checkWidgetVersion(myDocument){
	var myVersion = myDocument.getElementsByTagName('apiResults')[0].getAttributeNode("developerappversion").nodeValue;
	if (myVersion > WIDGETVERSION){
		var myNode = document.getElementById("lnkBtUpdateWidget");
		var myStart = myNode.title.indexOf("(");
		var myEnd = myNode.title.indexOf(")");
		myNode.title = myNode.title.substring(0,myStart+1)
			+ myVersion
			+ myNode.title.substring(myEnd, myNode.title.length);
		document.getElementById("lnkUpdateWidget").style.display = "block"
		document.getElementById("divNewWidgetVersion").innerText = myVersion;
	} else
		document.getElementById("lnkUpdateWidget").style.display = "none";
}

function returnTag(myParent, myChild){	// extracts returns tags out of an xml-document
	var myVar = myParent.getElementsByTagName(myChild)[0];
	return myVar.firstChild.nodeValue;
}

function shortenString(myString){	// shorten string for output in dropdown-menu
	if (myString.length > MYSTRINGLENGTH){
		myString = myString.substring(0,MYSTRINGLENGTH) + "...";
	}
	return myString;
}

function returnDelimitedNumber(myInput){	// change something like "1000" to "1,000"
	myStr = String(myInput);
	if (Number(myStr) >= 1000){
		myStr = String(myStr);
		var myErg = "";
		for (i=0 ; i<=myStr.length ; i++){ myErg = myStr.charAt (i) + myErg; }
		myErg = myErg.replace(/(\d\d\d)/g,'$1\,');
		myStr = "";
		for (i=0 ; i<=myErg.length ; i++){ myStr = myErg.charAt (i) + myStr; }
		if (myStr.substr(0,1) == ",") myStr = myStr.substr(1,myStr.length);
		myStr = myStr.replace(/\.,/, ",");
	}
	if (Number(myStr) == 0) myStr = "-";
	return myStr;
}

function showStatusMsg(mySwitch){	// show/hide spinning wheel, and show status
	myRequestStatus = mySwitch.toUpperCase();
	for (var i=0 ; i< ERR_ARR.length ; i++){
		if (myRequestStatus.indexOf(ERR_ARR[i].ErrString) != -1){
			alert("x" + ERR_ARR[i].ErrMsg);
			document.getElementById("statusText").innerText = ERR_ARR[i].ErrMsg;
			document.getElementById("spinWheel").innerHTML = ERR_ARR[i]["Spin"];
			break;
		}
	}
}